

**This documentation is for Version 1 of the Amazon CLI only.**

We announced the upcoming end-of-support for the Amazon CLI version 1. We recommend that you migrate to the Amazon CLI version 2. For dates, additional details, and information on how to migrate, see the [announcement](https://amazonaws-china.com/blogs/developer/cli-v1-maintenance-mode-announcement/). For documentation related to Version 2 of the Amazon CLI, see the [Version 2 User Guide](https://docs.amazonaws.cn/cli/latest/userguide/).

# Installing, updating, and uninstalling the Amazon CLI version 1 on macOS
<a name="install-macos"></a>

You can install the Amazon Command Line Interface (Amazon CLI) version 1 and its dependencies on macOS by using the bundled installer or `pip`. 

**Topics**
+ [Prerequisites](#install-macosos-prereq)
+ [Install, update and uninstall the Amazon CLI version 1 on macOS using the bundled installer](#install-macosos-bundled)
+ [Install, update and uninstall the Amazon CLI version 1 using pip](#awscli-install-osx-pip)
+ [Troubleshooting Amazon CLI install and uninstall errors](#awscli-install-osx-tshoot)

## Prerequisites
<a name="install-macosos-prereq"></a>

Before you can install the Amazon CLI version 1 on macOS, be sure you have Python 3.8 or later installed. For installation instructions, see the [Downloading Python](https://wiki.python.org/moin/BeginnersGuide/Download) page in Python's *Beginner Guide*.

**Python version support matrix**


| Amazon CLI version | Supported Python version | 
| --- | --- | 
| 1.39.0 – current | Python 3.9\$1 | 
| 1.32.0 – 1.38.38 | Python 3.8\$1 | 
| 1.27.0 – 1.31.x | Python 3.7\$1 | 
| 1.20.0 – 1.26.x | Python 3.6\$1 | 
| 1.19.0 – 1.19.x | Python 2.7\$1, Python 3.6\$1 | 
| 1.17 – 1.18.x | Python 2.7\$1, Python 3.4\$1 | 
| 1.0 – 1.16.x | Python 2.6 and older, Python 3.3 and older | 

## Install, update and uninstall the Amazon CLI version 1 on macOS using the bundled installer
<a name="install-macosos-bundled"></a>

On Linux or macOS, you can use the bundled installer to install version 1 of the Amazon Command Line Interface (Amazon CLI). The bundled installer includes all dependencies and can be used offline.

The bundled installer doesn't support installing to paths that contain spaces.

**Topics**
+ [Install the Amazon CLI version 1 using the bundled installer with `sudo`](#install-macosos-bundled-sudo)
+ [Install the Amazon CLI version 1 using the bundled installer without `sudo`](#install-macosos-bundled-no-sudo)
+ [Uninstall the Amazon CLI version 1 bundled installer](#install-macosos-bundled-uninstall)

### Install the Amazon CLI version 1 using the bundled installer with `sudo`
<a name="install-macosos-bundled-sudo"></a>

The following steps enable you to install the Amazon CLI version 1 from the command line on any build of macOS.

The following is a summary of the installation commands that you can cut and paste to run as a single set of commands.

**For the latest version of the Amazon CLI,** use the following command block:

```
$ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
unzip awscli-bundle.zip
sudo ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws
```

**For a specific version of the Amazon CLI,** append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following command:

```
$ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip" -o "awscli-bundle.zip"
unzip awscli-bundle.zip
sudo ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws
```

**To install the Amazon CLI version 1 using the bundled installer**

1. Download the Amazon CLI version 1 bundled installer in one of the following ways:
   + Download using the `curl` command.

     **For the latest version of the Amazon CLI,** use the following command block:

     ```
     $ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
     ```

     **For a specific version of the Amazon CLI,** append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following command:

     ```
     $ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip" -o "awscli-bundle.zip"
     ```
   + Download using the direct link.

     **For the latest version of the Amazon CLI:** [https://s3.amazonaws.com/aws-cli/awscli-bundle.zip](https://s3.amazonaws.com/aws-cli/awscli-bundle.zip)

     **For a specific version of the Amazon CLI, **append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following url [https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip](https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip)

1. Extract (unzip) the files from the package. If you don't have `unzip`, use your macOs distribution's built-in package manager to install it.

   ```
   $ unzip awscli-bundle.zip
   ```

1. Run the install program. The installer installs the Amazon CLI at `/usr/local/aws` and creates the symlink `aws` at the `/usr/local/bin` folder. Using the `-b` option to create a symlink eliminates the need to specify the install folder in the user's `$PATH` variable. This should enable all users to call the Amazon CLI by entering `aws` from any directory.

   ```
   $ sudo ./awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws
   ```

   By default, the install script runs under the system default version of Python. If you have installed an alternative version of Python and want to use that to install the Amazon CLI, run the install script with that version by absolute path to the Python executable, as follows.

   ```
   $ sudo /usr/local/bin/python3.7 awscli-bundle/install -i /usr/local/aws -b /usr/local/bin/aws
   ```

1. Verify that the Amazon CLI installed correctly.

   ```
   $ aws --version
   aws-cli/1.40.41 Python/3.11.6 Linux/5.10.205-195.807.amzn2.x86_64 botocore/1.18.6
   ```

   If you get an error, see [Troubleshooting errors for the Amazon CLI](cli-chap-troubleshooting.md).

### Install the Amazon CLI version 1 using the bundled installer without `sudo`
<a name="install-macosos-bundled-no-sudo"></a>

If you don't have `sudo` permissions or want to install the Amazon CLI only for the current user, you can use a modified version of the previous commands. The first two commands are the same. 

**For the latest version of the Amazon CLI,** use the following command block:

```
$ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
unzip awscli-bundle.zip
./awscli-bundle/install -b ~/bin/aws
```

**For a specific version of the Amazon CLI,** append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following command:

```
$ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip" -o "awscli-bundle.zip"
unzip awscli-bundle.zip
./awscli-bundle/install -b ~/bin/aws
```

**To install the Amazon CLI version 1 for the current user**

1. Download the Amazon CLI version 1 bundled installer using one of the the following methods:
   + Download using the `curl` command.

     **For the latest version of the Amazon CLI,** use the following command block:

     ```
     $ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle.zip" -o "awscli-bundle.zip"
     ```

     **For a specific version of the Amazon CLI,** append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following command:

     ```
     $ curl "https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip" -o "awscli-bundle.zip"
     ```
   + Download using the direct link.

     **For the latest version of the Amazon CLI:** [https://s3.amazonaws.com/aws-cli/awscli-bundle.zip](https://s3.amazonaws.com/aws-cli/awscli-bundle.zip)

     **For a specific version of the Amazon CLI, **append a hyphen and the version number to the filename. For this example the filename for version *1.16.312* would be `awscli-bundle-1.16.312.zip` resulting in the following url [https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip](https://s3.amazonaws.com/aws-cli/awscli-bundle-1.16.312.zip)

1. Extract the files from the package. If you don't have `unzip`, use your Linux distribution's built-in package manager to install it.

   ```
   $ unzip awscli-bundle.zip
   ```

1. Run the install program. The installer installs the Amazon CLI at `/usr/local/aws` and creates the symlink `aws` at the `/usr/local/bin` directory. The command uses the `-b` parameter to specify the directory where the installer places the `aws` symlink file. You must have write permissions to the specified directory.

   ```
   $ ./awscli-bundle/install -b ~/bin/aws
   ```

   This installs the Amazon CLI to the default location (`~/.local/lib/aws`) and creates a symbolic link (symlink) at `~/bin/aws`. Make sure that `~/bin` is in your `$PATH` environment variable for the symlink to work.

   ```
   $ echo $PATH | grep ~/bin     // See if $PATH contains ~/bin (output will be empty if it doesn't)
   $ export PATH=~/bin:$PATH     // Add ~/bin to $PATH if necessary
   ```

1. Ensure the folder that the Amazon CLI version 1 is installed in is part of your `$PATH` variable.

   1. Find your shell's profile script in your user folder. If you're not sure which shell you have, run `echo $SHELL`.

      ```
      $ ls -a ~
      .  ..  .bash_logout  .bash_profile  .bashrc  Desktop  Documents  Downloads
      ```
      + **Bash** – `.bash_profile`, `.profile`, or `.bash_login`
      + **Zsh** – `.zshrc`
      + **Tcsh** – `.tcshrc`, `.cshrc` or `.login`

   1. Add an export command at the end of your profile script that's similar to the following example.

      ```
      export PATH=~/.local/bin:$PATH
      ```

      This command inserts the path, `~/.local/bin` in this example, at the front of the existing `PATH` variable.

   1. Reload the profile into your current session to put those changes into effect.

      ```
      $ source ~/.bash_profile
      ```

1. Verify that the Amazon CLI installed correctly.

   ```
   $ aws --version
   aws-cli/1.40.41 Python/3.11.6 Linux/5.10.205-195.807.amzn2.x86_64 botocore/1.18.6
   ```

   If you get an error, see [Troubleshooting errors for the Amazon CLI](cli-chap-troubleshooting.md).

### Uninstall the Amazon CLI version 1 bundled installer
<a name="install-macosos-bundled-uninstall"></a>

1. The bundled installer puts everything inside of the installation directory except the optional symlink, so to uninstall, you just need to delete those two items.

   ```
   $ sudo rm -rf /usr/local/aws
   $ sudo rm /usr/local/bin/aws
   ```

1. **(Optional)** Remove the shared Amazon SDK and Amazon CLI settings information in the `.aws` folder.
**Warning**  
These configuration and credentials settings are shared across all Amazon SDKs and the Amazon CLI. If you remove this folder, they cannot be accessed by any Amazon SDKs that are still on your system.

   The default location of the `.aws` folder differs between platforms, by default the folder is located in *\$1/.aws/*. If your user has write permission to this directory, you don't need to use `sudo`.

   ```
   $ sudo rm ~/.aws/
   ```

## Install, update and uninstall the Amazon CLI version 1 using pip
<a name="awscli-install-osx-pip"></a>

You can use `pip` directly to install the Amazon CLI. 

**Topics**
+ [Install pip](#awscli-install-osx-pip-pip)
+ [Install and update the Amazon CLI using pip](#awscli-install-osx-pip-install)
+ [Add the Amazon CLI version 1 executable to your macOS command line path](#awscli-install-osx-path)
+ [Uninstall the Amazon CLI using pip](#awscli-install-osx-pip-uninstall)

### Install pip
<a name="awscli-install-osx-pip-pip"></a>

If you don't already have `pip` installed, you can install it by using the script that the *Python Packaging Authority* provides. Run `pip --version` to see if your version of Linux already includes Python and `pip`. We recommend that if you have Python version 3 or later installed, you use the `pip3` command.

1. Use the `curl` command to download the installation script. The following command uses the `-O` (uppercase "O") parameter to specify that the downloaded file is to be stored in the current folder using the same name it has on the remote host.

   ```
   $ curl -O https://bootstrap.pypa.io/get-pip.py
   ```

1. Run the script with the `python` or `python3` command to download and install the latest version of `pip` and other required support packages. When you include the `--user` switch, the script installs `pip` to the path `~/.local/bin`.

   ```
   $ python3 get-pip.py --user
   ```

### Install and update the Amazon CLI using pip
<a name="awscli-install-osx-pip-install"></a>

1. Use the `pip` or `pip3` command to install the Amazon CLI. We recommend that if you use Python version 3 or later, that you use the `pip3` command.

   **For the latest version of the Amazon CLI,** use the following command block:

   ```
   $ pip3 install awscli --upgrade --user
   ```

   **For a specific version of the Amazon CLI,** append two equals signs `=` and the version number to the filename. For this example the filename for version *1.16.312* would be *==1.16.312* resulting in the following command:

   ```
   $ pip3 install awscli==1.16.312 --upgrade --user
   ```
**Note**  
Use appropriate quoting rules for your terminal. To use the `=` character, you might need to use single or double quotes to escape properly. The following example escapes using single quotes:  

   ```
   $ pip3 install 'awscli==1.16.312' --upgrade --user
   ```

1. Verify that the Amazon CLI is installed correctly.

   ```
   $ aws --version
   aws-cli/1.40.41 Python/3.11.6 Darwin/23.3.0 botocore/1.18.6
   ```

   If the program isn't found, [add it to your command line path](#awscli-install-osx-path).

### Add the Amazon CLI version 1 executable to your macOS command line path
<a name="awscli-install-osx-path"></a>

After installing with `pip`, you might need to add the `aws` program to your operating system's `PATH` environment variable. The location of the program depends on where Python is installed.

**Example Amazon CLI install location - macOS with Python 3.6 and `pip` (user mode)**  

```
~/Library/Python/3.7/bin
```
Substitute the version of Python that you have for the version in the previous example.

If you don't know where Python is installed, run `which python`.

```
$ which python
/usr/local/bin/python
```

The output might be the path to a symlink, not the actual program. Run `ls -al` to see where it points.

```
$ ls -al /usr/local/bin/python
~/Library/Python/3.7/bin/python3.7
```

`pip` installs programs in the same folder that contains the Python application. Add this folder to your `PATH` variable.

**To modify your `PATH` variable**

1. Find your shell's profile script in your user directory. If you're not sure which shell you have, run `echo $SHELL`.

   ```
   $ ls -a ~
   .  ..  .bash_logout  .bash_profile  .bashrc  Desktop  Documents  Downloads
   ```
   + **Bash** – `.bash_profile`, `.profile`, or `.bash_login`
   + **Zsh** – `.zshrc`
   + **Tcsh** – `.tcshrc`, `.cshrc`, or `.login`

1. Add an export command to your profile script.

   ```
   export PATH=~/.local/bin:$PATH
   ```

   This command adds a path, `~/.local/bin` in this example, to the current `PATH` variable.

1. Load the updated profile into your current session.

   ```
   $ source ~/.bash_profile
   ```

### Uninstall the Amazon CLI using pip
<a name="awscli-install-osx-pip-uninstall"></a>

1. If you installed the Amazon CLI version 1 using `pip`, you must also uninstall using `pip`.

   ```
   $ pip uninstall awscli
   ```

    If you are using version Python 2 or 3, you might need to use the `pip2` or `pip3` command. Use the `aws --version` command to determine the Python version associated with your installed Amazon CLI version 1.

   ```
   $ pip3 uninstall awscli
   ```

   You might need to restart your command prompt window or your computer to remove all files.

1. **(Optional)** Remove the shared Amazon SDK and Amazon CLI settings information in the `.aws` folder.
**Warning**  
These configuration and credentials settings are shared across all Amazon SDKs and the Amazon CLI. If you remove this folder, they cannot be accessed by any Amazon SDKs that are still on your system.

   The default location of the `.aws` folder differs between platforms, by default the folder is located in *\$1/.aws/*. If your user has write permission to this directory, you don't need to use `sudo`.

   ```
   $ sudo rm -rf ~/.aws/
   ```

## Troubleshooting Amazon CLI install and uninstall errors
<a name="awscli-install-osx-tshoot"></a>

If you come across issues after installing or uninstalling the Amazon CLI, see [Troubleshooting errors for the Amazon CLI](cli-chap-troubleshooting.md) for troubleshooting steps. For the most relevant troubleshooting steps, see [Command not found errors](cli-chap-troubleshooting.md#tshoot-install-not-found), [The "`aws --version`" command returns a different version than you installed](cli-chap-troubleshooting.md#tshoot-install-wrong-version), and [The "`aws --version`" command returns a version after uninstalling the Amazon CLI](cli-chap-troubleshooting.md#tshoot-uninstall-1).